package Dungeon::Command;

sub new {
  my $ref = shift;
  my $class = ref($ref) || $ref;

  my $self = {
    error => "do that",
    req => [],
    @_
  }, bless $class;

  unshift @{ $self->{req} }, 'Character';

  return $self;
}

sub ok {
  my ( $self, @objs ) = @_;

  return 0 if ( @objs != @{ $self->{req} } );

  for ( 1 .. $#objs ) {
    return 0 if ( ref( $objs[$_] ) =~ /^Dungeon::Object::$self->{req}->[$_]/i );
  }

  return 1;
}

sub error {
  return "Sorry, you can't " . $_[0]->{error} . ".";
}

sub canCause {
  return $_[0]->ok( @_[1..$#_] );
}

sub effect {
  return $_[0]->error() if ( $_[0]->canCause() || ( ! $_[0]->ok($_[0..$#_]) ) );
  return "You did nothing.";
}
1;
