package Dungeon::Command::Move;

@ISA = qw( Dungeon::Command );

sub new {
  SUPER::new( error => 'go there', @_[1..$#_] );
}

sub canCause {
  my ( $self, $person ) = @_;

  return $self->ok( $person ) &&
    $person->can( 'Move' ) &&
    $person->{data}{Position}->can( "Move::$self->{name}", $person );
}

sub effect {
  my ( $self, $person ) = @_;

  if ( $self->canCause( $person ) ) {
    $person->{data}{Position} = $person->{data}{Position}{ $self->{name} };
    return "You moved to the $self->{name}\.";
  } else {
    return $self->error();
  }
}
1;
